summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--.config/shell/aliasrc9
-rwxr-xr-x.local/bin/dmenumount67
-rwxr-xr-x.local/bin/dmenuumount21
-rwxr-xr-x.local/bin/mounter19
4 files changed, 21 insertions, 95 deletions
diff --git a/.config/shell/aliasrc b/.config/shell/aliasrc
index 0541d0f..09f9a32 100644
--- a/.config/shell/aliasrc
+++ b/.config/shell/aliasrc
@@ -6,12 +6,17 @@
# Use $XINITRC variable if file exists.
[ -f "$XINITRC" ] && alias startx="startx $XINITRC"
+[ -f "$MBSYNCRC" ] && alias mbsync="mbsync -c $MBSYNCRC"
+
# sudo not required for some system commands
for command in mount umount sv pacman updatedb su shutdown poweroff reboot ; do
alias $command="sudo $command"
done; unset command
-se() { cd ~/.local/bin; $EDITOR $(fzf) ;}
+se() {
+ choice="$(find ~/.local/bin -mindepth 1 -printf '%P\n' | fzf)"
+ [ -f "$HOME/.local/bin/$choice" ] && $EDITOR "$HOME/.local/bin/$choice"
+ ;}
# Verbosity and settings that you pretty much just always are going to want.
alias \
@@ -19,9 +24,11 @@ alias \
mv="mv -iv" \
rm="rm -vI" \
bc="bc -ql" \
+ rsync="rsync -vrPlu" \
mkd="mkdir -pv" \
yt="yt-dlp --embed-metadata -i" \
yta="yt -x -f bestaudio/best" \
+ ytt="yt --skip-download --write-thumbnail" \
ffmpeg="ffmpeg -hide_banner"
# Colorize commands when possible.
diff --git a/.local/bin/dmenumount b/.local/bin/dmenumount
deleted file mode 100755
index 8cf4a6b..0000000
--- a/.local/bin/dmenumount
+++ /dev/null
@@ -1,67 +0,0 @@
-#!/bin/sh
-
-# Gives a dmenu prompt to mount unmounted drives and Android phones. If
-# they're in /etc/fstab, they'll be mounted automatically. Otherwise, you'll
-# be prompted to give a mountpoint from already existsing directories. If you
-# input a novel directory, it will prompt you to create that directory.
-
-getmount() { \
- [ -z "$chosen" ] && exit 1
- # shellcheck disable=SC2086
- mp="$(find $1 2>/dev/null | dmenu -i -p "Type in mount point.")" || exit 1
- test -z "$mp" && exit 1
- if [ ! -d "$mp" ]; then
- mkdiryn=$(printf "No\\nYes" | dmenu -i -p "$mp does not exist. Create it?") || exit 1
- [ "$mkdiryn" = "Yes" ] && (mkdir -p "$mp" || sudo -A mkdir -p "$mp")
- fi
- }
-
-mountusb() { \
- chosen="$(echo "$usbdrives" | dmenu -i -p "Mount which drive?")" || exit 1
- chosen="$(echo "$chosen" | awk '{print $1}')"
- sudo -A mount "$chosen" 2>/dev/null && notify-send "💻 USB mounting" "$chosen mounted." && exit 0
- alreadymounted=$(lsblk -nrpo "name,type,mountpoint" | awk '$3!~/\/boot|\/home$|SWAP/&&length($3)>1{printf "-not ( -path *%s -prune ) ",$3}')
- getmount "/mnt /media /mount /home -maxdepth 5 -type d $alreadymounted"
- partitiontype="$(lsblk -no "fstype" "$chosen")"
- case "$partitiontype" in
- "vfat") sudo -A mount -t vfat "$chosen" "$mp" -o rw,umask=0000;;
- "exfat") sudo -A mount "$chosen" "$mp" -o uid="$(id -u)",gid="$(id -g)";;
- *) sudo -A mount "$chosen" "$mp"; user="$(whoami)"; ug="$(groups | awk '{print $1}')"; sudo -A chown "$user":"$ug" "$mp";;
- esac && notify-send "💻 USB mounting" "$chosen mounted to $mp." ||
- notify-send "💻 Drive failed to mount." "Probably a permissions issue or drive is already mounted."
- }
-
-mountandroid() { \
- chosen="$(echo "$anddrives" | dmenu -i -p "Which Android device?")" || exit 1
- chosen="$(echo "$chosen" | cut -d : -f 1)"
- getmount "$HOME -maxdepth 3 -type d"
- echo "OK" | dmenu -i -p "Tap Allow on your phone if it asks for permission and then press enter" || exit 1
- simple-mtpfs --device "$chosen" "$mp" &&
- notify-send "🤖 Android Mounting" "Android device mounted to $mp." ||
- notify-send "🤖 Android failed mounting." "Probably a permissions issue or phone is already mounted."
- }
-
-asktype() { \
- choice="$(printf "USB\\nAndroid" | dmenu -i -p "Mount a USB drive or Android device?")" || exit 1
- case $choice in
- USB) mountusb ;;
- Android) mountandroid ;;
- esac
- }
-
-anddrives=$(simple-mtpfs -l 2>/dev/null)
-usbdrives="$(lsblk -rpo "name,type,size,label,mountpoint,fstype" | grep -v crypto_LUKS | grep 'part\|rom' | sed 's/ /:/g' | awk -F':' '$5==""{printf "%s (%s) %s\n",$1,$3,$4}')"
-
-if [ -z "$usbdrives" ]; then
- [ -z "$anddrives" ] && echo "No USB drive or Android device detected" && exit
- echo "Android device(s) detected."
- mountandroid
-else
- if [ -z "$anddrives" ]; then
- echo "USB drive(s) detected."
- mountusb
- else
- echo "Mountable USB drive(s) and Android device(s) detected."
- asktype
- fi
-fi
diff --git a/.local/bin/dmenuumount b/.local/bin/dmenuumount
deleted file mode 100755
index 656d1f1..0000000
--- a/.local/bin/dmenuumount
+++ /dev/null
@@ -1,21 +0,0 @@
-#!/bin/sh
-
-# A dmenu prompt to unmount drives.
-# Provides you with mounted partitions, select one to unmount.
-# Drives mounted at /, /boot and /home will not be options to unmount.
-
-drives="$(lsblk -nrpo "name,type,size,mountpoint,label" | awk -F':' '{gsub(/ /,":")}$4!~/\/boot|\/efi|\/home$|SWAP/&&length($4)>1{printf "%s (%s) %s\n",$4,$3,$5}'; awk '/simple-mtpfs/ { print "📱", $2; }' /etc/mtab)"
-
-chosen="$(echo "$drives" | dmenu -i -p "Unmount which drive?")" || exit 1
-
-case "$chosen" in
- 📱*)
- chosen="${chosen#📱 }"
- sudo -A umount -l "$chosen"
- ;;
- *)
- chosen="${chosen% (*}"
- sudo -A umount -l "$chosen"
- ;;
-esac && notify-send "🖥️ Drive unmounted." "$chosen successfully unmounted." ||
- notify-send "🖥️ Drive failed to unmount." "Possibly a permissions or I/O issue."
diff --git a/.local/bin/mounter b/.local/bin/mounter
index d7c1b06..3b2a314 100755
--- a/.local/bin/mounter
+++ b/.local/bin/mounter
@@ -4,7 +4,7 @@
# replace the older `dmenumount` which had extra steps and couldn't handle
# encrypted drives.
# TODO: Remove already mounted Android phones from prompt.
-# TODO: Try mount first for drives if in fstab to avoid directory prompt?
+# TODO: Try decrypt for drives in crtypttab
# TODO: Add some support for connecting iPhones (although they are annoying).
set -e
@@ -54,12 +54,19 @@ getmount(){
fi
}
+attemptmount(){
+ # Attempt to mount without a mountpoint, to see if drive is in fstab.
+ sudo -A mount "$chosen" || return 1
+ notify-send "💾Drive Mounted." "$chosen mounted."
+ exit
+}
+
case "$chosen" in
💾*)
chosen="${chosen%% *}"
chosen="${chosen:1}" # This is a bashism.
- getmount
- sudo -A mount "$chosen" "$mp"
+ attemptmount || getmount
+ sudo -A mount "$chosen" "$mp" -o uid="$(id -u)",gid="$(id -g)"
notify-send "💾Drive Mounted." "$chosen mounted to $mp."
;;
@@ -77,14 +84,14 @@ case "$chosen" in
# Check if now decrypted.
test -b "/dev/mapper/usb$num"
- getmount
- sudo -A mount "/dev/mapper/usb$num" "$mp"
+ attemptmount || getmount
+ sudo -A mount "/dev/mapper/usb$num" "$mp" -o uid="$(id -u)",gid="$(id -g)"
notify-send "🔓Decrypted drive Mounted." "$chosen decrypted and mounted to $mp."
;;
📱*)
+ notify-send "❗Note" "Remember to allow file access on your phone now."
getmount
- echo "OK" | dmenu -i -p "Tap Allow on your phone if it asks for permission and then press enter"
chosen="${chosen%%:*}"
chosen="${chosen:1}" # This is a bashism.
sudo -A simple-mtpfs -o allow_other --device "$chosen" "$mp"